︠5bb4c839-6c35-4a23-8050-1964590529c3i︠
%html
<p><span style="text-decoration: underline;">Blum Blum Shub</span></p>
<p>L'algorithme de Blum Blum Shub permet de g&eacute;n&eacute;rer des suites pseudo-al&eacute;atoires cryptographiquement s&ucirc;res. C'est-&agrave;-dire qu'un attaquant ne peut pas pr&eacute;voir le prochain nombre $x_{n+1}$ de cette suite en connaissant uniquement les premiers &eacute;l&eacute;ments $x_1,\ldots,x_n$.</p>
<p>La d&eacute;finition de cet algorithme est assez simple:</p>
<p>on choisit deux nombres premiers $p$ et $q$ et on consid&egrave;re $N=p*q$.</p>
<p>La cl&eacute; sera l'&eacute;l&eacute;ment initial $x_0$ de notre suite que l'on d&eacute;finit par la r&eacute;currence $x_{n+1}=x_n^2 \pmod N$.</p>

︡b5c51908-f520-4525-8455-b3c43fcc5561︡{"html": "<p><span style=\"text-decoration: underline;\">Blum Blum Shub</span></p>\n<p>L'algorithme de Blum Blum Shub permet de g&eacute;n&eacute;rer des suites pseudo-al&eacute;atoires cryptographiquement s&ucirc;res. C'est-&agrave;-dire qu'un attaquant ne peut pas pr&eacute;voir le prochain nombre $x_{n+1}$ de cette suite en connaissant uniquement les premiers &eacute;l&eacute;ments $x_1,\\ldots,x_n$.</p>\n<p>La d&eacute;finition de cet algorithme est assez simple:</p>\n<p>on choisit deux nombres premiers $p$ et $q$ et on consid&egrave;re $N=p*q$.</p>\n<p>La cl&eacute; sera l'&eacute;l&eacute;ment initial $x_0$ de notre suite que l'on d&eacute;finit par la r&eacute;currence $x_{n+1}=x_n^2 \\pmod N$.</p>"}︡
︠cf31c55f-32ad-4a98-a65a-11c7a2f270a3︠
p=1483; q=1487; N = p*q
︡4da906d6-461e-483e-814b-99a8137d5664︡︡
︠100ee185-a797-4c8d-8146-8c737338d704i︠
%html
<p>exemple de suite g&eacute;n&eacute;r&eacute;e avec comme cl&eacute; $17$:</p>

︡1095a7bd-5041-41bf-860b-cd09144be82e︡{"html": "<p>exemple de suite g&eacute;n&eacute;r&eacute;e avec comme cl&eacute; $17$:</p>"}︡
︠fced3b6e-0800-4e39-ba37-a0d7196d45fe︠
cle = 17; x=[0]*10; x[0] = cle
for i in (1..9):
    x[i] = x[i-1]**2 % N
x
︡19718e44-fd9f-4b33-bf7c-1cf905939ca9︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[17, 289, 83521, 643418, 584394, 386629, 1078156, 2061595, 790642, 775294\\right]</span>"}︡
︠819a25bb-9099-4a18-89d3-6de2d53f6c31i︠
%html
<p>Pour chiffrer un message, un premi&egrave;re &eacute;tape consiste &agrave; transformer une suite de lettres en une suite de chiffres. C'est ce que l'on appelle le codage.</p>
<p>Pour cela, nous allons consid&eacute;rer un alphabet (avec en plus des chiffres, des signes de ponctuation, etc) et chaque caract&egrave;re sera remplac&eacute; par l'entier correspondant &agrave; sa position.</p>

︡fbef534a-e437-4d86-ad5e-f414e50698f7︡{"html": "<p>Pour chiffrer un message, un premi&egrave;re &eacute;tape consiste &agrave; transformer une suite de lettres en une suite de chiffres. C'est ce que l'on appelle le codage.</p>\n<p>Pour cela, nous allons consid&eacute;rer un alphabet (avec en plus des chiffres, des signes de ponctuation, etc) et chaque caract&egrave;re sera remplac&eacute; par l'entier correspondant &agrave; sa position.</p>"}︡
︠03232b49-7053-4605-a6db-27de24b16f12︠
alphabet = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789,.?! "
︡6cf25ed4-ae7c-462d-b1c5-2b9570148cd5︡︡
︠4d444e81-59f3-4f67-aebd-8ceb41868507︠
def code(message):
    return [alphabet.index(lettre) for lettre in message]
︡79d17e5c-ee84-447d-966b-1c3928b27da7︡︡
︠99242afb-d05c-4ed1-95ff-f7ba2d5e3b5ai︠
%html
<p>Un exemple:</p>
<p>on remarquera que la premi&egrave;re lettre de l'alphabet, ici $a$ est consid&eacute;r&eacute;e comme &eacute;tant en position $0$.</p>

︡1120cc46-4a81-4287-a7f5-b8eb6813b143︡{"html": "<p>Un exemple:</p>\n<p>on remarquera que la premi&egrave;re lettre de l'alphabet, ici $a$ est consid&eacute;r&eacute;e comme &eacute;tant en position $0$.</p>"}︡
︠2491f4d4-29f7-482b-8136-4082bf594f47︠
code('allo!')
︡d5dc39d9-c8e4-48c5-9ad9-9141b254549f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[0, 11, 11, 14, 65\\right]</span>"}︡
︠1f866b18-2ee5-4672-a937-539bb5319650i︠
%html
<p>Le passage inverse d'un entier &agrave; une lettre est appel&eacute; le d&eacute;codage.</p>

︡cc80e994-7c10-4b65-a461-8c44578077ab︡{"html": "<p>Le passage inverse d'un entier &agrave; une lettre est appel&eacute; le d&eacute;codage.</p>"}︡
︠22287b4d-6222-4990-bc87-27186ab93eb9︠
def decode(sequence):
    return ''.join([alphabet[i] for i in sequence])
︡ece09545-0c95-41e4-9609-0beb51a7f193︡︡
︠2aed4982-fb0e-405d-b25a-a309ec435e02i︠
%html
<p>on v&eacute;rifie que cela fonctionne bien:</p>

︡57f5e57c-0510-4ef1-8161-69885bf16a3e︡{"html": "<p>on v&eacute;rifie que cela fonctionne bien:</p>"}︡
︠b00aff01-4e90-4383-8633-34de4488acb0︠
decode([0, 11, 11, 14, 65])
︡64285bcc-3e20-4ff6-8830-77861157dfb5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{allo!}</span>"}︡
︠e24e7b25-3d40-4d03-811c-236e46aed2cfi︠
%html
<p>Le principe des chiffrements &agrave; flots est alors le suivant.</p>
<p>On g&eacute;n&eacute;re une suite d'entiers de la m&ecirc;me taille que notre message &agrave; partir de notre cl&eacute;. Cette suite est appel&eacute;e <span style="text-decoration: underline;">suite chiffrante</span>. Le chiffrement du message est alors une simple addition modulo la taille de notre alphabet.</p>

︡dd31314b-448d-4f14-86f4-06685e13d38e︡{"html": "<p>Le principe des chiffrements &agrave; flots est alors le suivant.</p>\n<p>On g&eacute;n&eacute;re une suite d'entiers de la m&ecirc;me taille que notre message &agrave; partir de notre cl&eacute;. Cette suite est appel&eacute;e <span style=\"text-decoration: underline;\">suite chiffrante</span>. Le chiffrement du message est alors une simple addition modulo la taille de notre alphabet.</p>"}︡
︠7e321b0f-fd1b-498d-a302-d168edca41b4︠
def chiffre_sequence(sequence,cle):
    taille_alphabet = len(alphabet)
    suite_chiffrante = cle
    for position,lettre in enumerate(sequence):
        suite_chiffrante = suite_chiffrante**2 % N         # la recurrence de Blum Blum Shub
        sequence[position] = (lettre+suite_chiffrante)%taille_alphabet
    return sequence
︡3085cd20-b52e-46ae-b2de-c21009ee9385︡︡
︠1e44c939-8a40-4722-a9ac-985821dd4a4fi︠
%html
<p>un exemple:</p>

︡4bb786a4-5236-420e-bc39-0c2a46a5790b︡{"html": "<p>un exemple:</p>"}︡
︠2b5bdf3c-e3ce-4904-a693-4ab4d7d0a369︠
chiffre_sequence([0, 11, 11, 14, 65],17)
︡7b5c38cf-88c2-4482-a7ce-83e1607cafc6︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[21, 50, 28, 34, 37\\right]</span>"}︡
︠00695aa6-4c6c-4b60-a99d-2db79901cb16i︠
%html
<p>Notre alphabet est de taille $67$. On a ici:</p>
<ul>
<li>$17^2 = 289 \pmod N$ et $0 + 289 \pmod 67 = 21$</li>
<li>$289^2 = 83521 \pmod N$ et $11 + 83521 \pmod 67 = 50$</li>
<li>etc</li>
</ul>
<p>et en utilisant nos fonction $code$ et $decode$, on peut obtenir un message chiffr&eacute; dans notre alphabet de d&eacute;part.</p>

︡6842d0be-1123-4dda-9ee2-2b4dd2011a45︡{"html": "<p>Notre alphabet est de taille $67$. On a ici:</p>\n<ul>\n<li>$17^2 = 289 \\pmod N$ et $0 + 289 \\pmod 67 = 21$</li>\n<li>$289^2 = 83521 \\pmod N$ et $11 + 83521 \\pmod 67 = 50$</li>\n<li>etc</li>\n</ul>\n<p>et en utilisant nos fonction $code$ et $decode$, on peut obtenir un message chiffr&eacute; dans notre alphabet de d&eacute;part.</p>"}︡
︠7925c812-3cec-48c1-8805-08286f3570d3︠
def chiffre(message, cle):
    return decode(chiffre_sequence(code(message),cle))
︡ea249ba5-b632-4918-81bf-beaa3d2e78a9︡︡
︠d21a6052-3d76-4e43-8e93-bf99e613d906i︠
%html
<p>toujours notre exemple:</p>

︡83a9a2d9-d0a9-41b0-90ab-06f0e0d531c2︡{"html": "<p>toujours notre exemple:</p>"}︡
︠fefb553e-1d84-4c6d-a5ff-8f668d56b785︠
chiffre('allo!',cle)
︡fad3e14c-5c2f-49b9-bdeb-626c7a9c988d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{vYCIL}</span>"}︡
︠191c9ccb-8ab7-47e9-9725-221d97e33114i︠
%html
<p>Pour d&eacute;chiffrer, il suffit de faire la m&ecirc;me chose en rempla&ccedil;ant l'addition par une soustraction.</p>
<p>Ainsi on a, en notant $m$ le message initial, $s$ la suite chiffrante, $c$ le message chiffr&eacute; et $d$ le message d&eacute;chiffr&eacute;:</p>
<ul>
<li>$c = m+s \pmod N$</li>
<li>et $d = c - s \pmod N$</li>
<li>d'o&ugrave; $d = m+s-s \pmod N = m$</li>
</ul>
<p>&nbsp;</p>

︡67e7da3b-3182-4efe-b9d9-d02d27fc965f︡{"html": "<p>Pour d&eacute;chiffrer, il suffit de faire la m&ecirc;me chose en rempla&ccedil;ant l'addition par une soustraction.</p>\n<p>Ainsi on a, en notant $m$ le message initial, $s$ la suite chiffrante, $c$ le message chiffr&eacute; et $d$ le message d&eacute;chiffr&eacute;:</p>\n<ul>\n<li>$c = m+s \\pmod N$</li>\n<li>et $d = c - s \\pmod N$</li>\n<li>d'o&ugrave; $d = m+s-s \\pmod N = m$</li>\n</ul>\n<p>&nbsp;</p>"}︡
︠173b20d5-e04c-422e-b417-664802b110e4︠
def dechiffre_sequence(sequence,cle):
    taille_alphabet = len(alphabet)
    suite_chiffrante = cle
    for position,lettre in enumerate(sequence):
        suite_chiffrante = suite_chiffrante**2 % N
        sequence[position] = (lettre-suite_chiffrante)%taille_alphabet
    return sequence
︡1a6dbfca-e4b1-4f8b-a448-a88ede60a9ee︡︡
︠4b58bee8-646d-496a-ad04-c45ae8b1dec8︠
def dechiffre(message, cle):
    return decode(dechiffre_sequence(code(message),cle))
︡4aededf2-fc99-4fa4-978f-f8c3dabda139︡︡
︠778861cb-e804-44d7-bf85-e7da4fa29933i︠
%html
<p>Si on utilise une cl&eacute; diff&eacute;rente, on ne peut pas lire le message obtenu</p>

︡da562d70-a633-4779-b063-faabdee1047a︡{"html": "<p>Si on utilise une cl&eacute; diff&eacute;rente, on ne peut pas lire le message obtenu</p>"}︡
︠6edcd7a9-77ac-4dd6-a2d6-7d93e7874230︠
dechiffre(chiffre('Bonjour!',19),17)
︡0a1df54d-513b-4195-9411-3bd8e7f58860︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{GWF lIgk}</span>"}︡
︠cfbbe67d-9fd3-4426-b459-2da8051e93e2i︠
%html
<p>mais si on utilise la bonne cl&eacute; on retrouve bien le message d'origine</p>

︡b1e4a84c-e23a-490b-9dd1-bfb8c3bb6af1︡{"html": "<p>mais si on utilise la bonne cl&eacute; on retrouve bien le message d'origine</p>"}︡
︠8769e40d-606e-4b8f-9b25-30d534e056f9︠
dechiffre(chiffre('Bonjour!',19),19)
︡15f78eed-023c-4240-810e-52c69596901d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Bonjour!}</span>"}︡
︠cb857aa9-8bf7-43c6-ab17-708b49e7d0adi︠
%html
<p>Exercice:</p>
<p>d&eacute;chiffrer le message suivant en utilisant la cl&eacute; $123$:&nbsp; <strong><span style="font-family: courier new,courier;">'wWAEP5guAZU0QvXx8QzJvXDZTmbcf6SxLPoyo1hany cS?8wVZ'</span></strong></p>
<p><span style="text-decoration: underline;">Conclusion et extensions</span></p>
<p>Le syst&egrave;me de Blum Blum Shub est int&eacute;ressant car on peut prouver (mais c'est compliqu&eacute;!) qu'il fourni une bonne s&eacute;curit&eacute;.</p>
<p>Cependant le principe des chiffrement &agrave; flots peut &ecirc;tre tr&egrave;s facilement adapt&eacute;, il suffit de choisir une autre suite r&eacute;currente.</p>
<p>Par exemple, on peut d&eacute;cider d'utiliser $x_{n+1} = x_n + 17 \pmod N$ mais on a alors aucune garantie quant &agrave; la s&eacute;curit&eacute;.</p>
<p>Comme on peut s'y attendre, cette suite est en fait trop simple pour r&eacute;sister...</p>
<p>Exercice:</p>
<p>d&eacute;chiffrer le message suivant chiffr&eacute; avec ce syst&egrave;me faible, sans conna&icirc;tre la cl&eacute;:&nbsp; <span style="font-family: courier new,courier;"><strong>'Irgsvidyridjsmwdfvezsaaa'</strong></span></p>

︡7d7b107b-cce9-4d26-93a1-b398a88b91f2︡{"html": "<p>Exercice:</p>\n<p>d&eacute;chiffrer le message suivant en utilisant la cl&eacute; $123$:&nbsp; <strong><span style=\"font-family: courier new,courier;\">'wWAEP5guAZU0QvXx8QzJvXDZTmbcf6SxLPoyo1hany cS?8wVZ'</span></strong></p>\n<p><span style=\"text-decoration: underline;\">Conclusion et extensions</span></p>\n<p>Le syst&egrave;me de Blum Blum Shub est int&eacute;ressant car on peut prouver (mais c'est compliqu&eacute;!) qu'il fourni une bonne s&eacute;curit&eacute;.</p>\n<p>Cependant le principe des chiffrement &agrave; flots peut &ecirc;tre tr&egrave;s facilement adapt&eacute;, il suffit de choisir une autre suite r&eacute;currente.</p>\n<p>Par exemple, on peut d&eacute;cider d'utiliser $x_{n+1} = x_n + 17 \\pmod N$ mais on a alors aucune garantie quant &agrave; la s&eacute;curit&eacute;.</p>\n<p>Comme on peut s'y attendre, cette suite est en fait trop simple pour r&eacute;sister...</p>\n<p>Exercice:</p>\n<p>d&eacute;chiffrer le message suivant chiffr&eacute; avec ce syst&egrave;me faible, sans conna&icirc;tre la cl&eacute;:&nbsp; <span style=\"font-family: courier new,courier;\"><strong>'Irgsvidyridjsmwdfvezsaaa'</strong></span></p>"}︡
